Description

In Ubuntu 13.10 with unity desktop, if i enable the options "show system tray icon" and "Hide to tray on close button" and close
quassel, the app disappears but there is no icon displayed on the notification area. So there is no way to bring the app to front.

Associated revisions

Revision 39398203 - 08/05/2014 12:42 PM - al

Fix notification icon not appearing in Unity

Unity's indicator expects certain properties to be exported by an
application, of which Quassel is lacking some. This adds IconThemePath,
Menu, ItemlsMenu to org.kde.StatusNotifierltem.

Thanks a lot to shiznix for providing this patch.

Fixes #1269

Revision 3fb5e209 - 06/16/2018 01:30 AM - al

Fix notification icon not appearing in Unity

Unity's indicator expects certain properties to be exported by an
application, of which Quassel is lacking some. This adds IconThemePath,
Menu, ItemlsMenu to org.kde.StatusNotifierltem.

Thanks a lot to shiznix for providing this patch.

Fixes #1269

(cherry picked from commit 3939820389d995f56a073fc1d54ab245c6558312)

History

#1 - 04/07/2014 10:02 PM - phunyguy

| will add a note for this as | have some experience with this bug. The issue is an incompatibility between the indicator-application package provided
by Unity and quassel(client?). This affects Xubuntu and Ubuntu 12.10 and above. 12.04 works flawless. If you remove the indicator-application
package, you get a tray icon, but lose all your Indicator stuff (volume control, battery icons, etc). Quassel-team: There have been instances in other
bugs | filed on Launchpad for this that get shrugged off as being Canonical's issue, meanwhile Canonical shrugs it off as Quassel's issue... but there
are plenty of other applications out there that have functioning tray icons, so | am leaning more towards this being an issue with Quassel and
Canonical not playing nice. Unity isn't going anywhere, so | hope that sometime in the future we can get both teams working together towards a
resolution. Quassel and Unity are both fantastic, and | would like to use them both together.

#2 - 05/04/2014 05:07 AM - kitterma

The Quassel icon works fine with anything except Unity, so | don't see how it's a Quassel issue. If there's something that's being done differently in
Unity that needs a change in quassel, then someone who knows something about Unity will have to provide it. None of the Quassel devs use Ubuntu
and it works fine in Kubuntu where it's mostly used.

#3 - 06/08/2014 02:42 AM - shiznix
- File SNI-systray_fix.diff added

Indicator-application displays application icons and their menus for applications that use the appindicator API.
But it can also display those that use kdelib's Status Notifier Items (SNI) spec.

Indicator-application does try and use Quassel's SNI but it is not quite complete, see the following output from indicator-application:
"indicator-application-service-WARNING **: Notification Item on object /StatusNotifierltem of org.kde.StatusNotifierltem-29780-1 doesn't have enough
properties" (where 29780 is the PID of Quassel)

Specifically, Quassel is missing registering org.kde.StatusNotifierltem.Menu on dbus.
Attached is a small patch to get a basic working Quassel SNI indicator that is compatible with indicator-application.

#4 - 07/06/2014 11:38 AM - al
- Status changed from New to Assigned

- Assignee set to al

#5 - 07/06/2014 11:41 AM - al

Seems to be the same bug as https://bugs.launchpad.net/ubuntu/+source/quassel/+bug/1299872

#6 - 07/06/2014 09:59 PM - al

shiznix, the patch doesn't seem to fix it for me. Is there anything else required except applying the patch, cmake -DWITH_KDE=ON; make install?

#7 - 08/05/2014 12:54 AM - shiznix
Hi al,

It should 'just work’, but I'll post what info | have in the hope it can get things happening at your end.

The available SNI items exported by quassel can be listed by doing the following:
gdbus org.kde.StatusNotifierltem-$(pidof quasselclient)-1 /StatusNotifierltem

The indicator-application-service process expects the following SNI items to be present before it will show an icon and menu:
org.kde.StatusNotifierltem.Menu

org.kde.StatusNotifierltem.Id

org.kde.StatusNotifierltem.Category

org.kde.StatusNotifierltem.Status

org.kde.StatusNotifierltem.lconName

These items are checked in indicator-application package's source file src/application-service-appstore.c
Once indicator-application-service is satisfied these SNI items exist, it shows the Quassel icon as an indicator in the Unity top panel with a basic
menu.

Have double checked again the patch works OK and applies to both quassel versions 0.9.3 and 0.10.0.

#8 - 08/05/2014 01:18 AM - shiznix
Hi al,

It should 'just work’, but I'll post what info | have in the hope it can get things happening at your end.

The available SNI items exported by quassel can be listed by doing the following:
gdbus org.kde.StatusNotifierltem-$(pidof quasselclient)-1 /StatusNotifierltem

The indicator-application-service process expects the following SNI items to be present before it will show an icon and menu:
org.kde.StatusNotifierltem.Menu

org.kde.StatusNotifierltem.Id

org.kde.StatusNotifierltem.Category

org.kde.StatusNotifierltem.Status

org.kde.StatusNotifierltem.lconName

These items are checked in indicator-application package's source file src/application-service-appstore.c
Once indicator-application-service is satisfied these SNI items exist, it shows the Quassel icon as an indicator in the Unity top panel with a basic
menu.

Have double checked again the patch works OK and applies to both quassel versions 0.9.3 and 0.10.0.
Only mandatory cmake build option | can think of is of course '-DWITH_DBUS=ON'".

#9 - 08/05/2014 12:37 PM - al

Still wasn't able to successfully test this, but | guess I'm doing something wrong. At least it doesn't break anything for me, so I'll just merge it. Thanks
for the patch!

#10 - 08/05/2014 12:45 PM - al
- Status changed from Assigned to Resolved

- % Done changed from 0 to 100
Applied in changeset quassellcommit:3939820389d995f56a073fc1d54ab245c6558312.

#11 - 08/29/2014 01:13 PM - al

- Status changed from Resolved to Feedback

Reopening as | had to revert the fix due to dbus errors:
arguments to dbus_message_iter_append_basic() were incorrect, assertion "_dbus_check_is_valid_path (*string_p)" failed in file dbus-message.c
line 2680.

Any hints appreciated.

#12 - 08/29/2014 01:13 PM - al
- % Done changed from 100 to 0

#13 - 03/19/2015 02:25 PM - dkessel

This not only affects unity, but also other desktop environments like XFCE. Tested on Xubuntu Development release 15.04.

#14 - 04/25/2015 01:15 AM - shiznix

al wrote:

Reopening as | had to revert the fix due to dbus errors:
arguments to dbus_message_iter_append_basic() were incorrect, assertion "_dbus_check_is_valid_path (*string_p)" failed in file
dbus-message.c line 2680.

Any hints appreciated.
Try as | might, I'm unable to reproduce this.
Al are you getting this error during building or at runtime ?
Patch still applies cleanly and works for versions 0.9, 0.10, 0.11 and 0.12 of Quassel here.

#15 - 06/07/2018 12:47 AM - Sputnick

Works fine for me as well, so this patch is coming back as part of the on-going systray refactoring.

#16 - 06/07/2018 12:59 AM - Sputnick

Actually, our SNI interface definition had the wrong types for pixmaps. This should be unrelated to this patch, but maybe one of the desktop
environments al tested on that ignored Quassel without the new properties then started to support Quassel, and tried to marshall the (empty)
pixmaps. KDE/Plasma don't do this, because they check if the argument is empty before trying to deserialize it, but maybe Unity behaves differently...

#17 - 06/16/2018 01:30 AM - al
- Status changed from Feedback to Resolved

- % Done changed from 0 to 100

Applied in changeset quassel|3fb5e2099ae51f15d73396c0af183a5569fd0589.

Files

SNI-systray_fix.diff 804 Bytes 06/08/2014 shiznix
